blob: 984a7ce0bc755ad87d9ecf77f4315867f8dd0c90 [file] [log] [blame]
Holger Hans Peter Freytherbb8d6812013-01-15 14:26:29 +01001#!/bin/sh
2### BEGIN INIT INFO
3# Provides: osmocom-bsc-nat
4# Required-Start: $network $local_fs
5# Required-Stop:
6# Default-Start: 2 3 4 5
7# Default-Stop: 0 1 6
8# Short-Description: Osmocom GSM network-in-a-box
9# Description: A minimal implementation of the GSM Base Station Controller,
10# Mobile Switching Center, Home Location regster and all other
11# components to run a self-contained GSM network.
12### END INIT INFO
13
14# Author: Harald Welte <laforge@gnumonks.org>
15
16# PATH should only include /usr/* if it runs after the mountnfs.sh script
17PATH=/sbin:/usr/sbin:/bin:/usr/bin
18NAME=osmo-bsc_nat # Introduce the short server's name here
19DESC="Osmocom GSM BSC Multiplexer (NAT)" # Introduce a short description here
20DAEMON=/usr/bin/osmo-bsc_nat # Introduce the server's location here
21SCRIPTNAME=/etc/init.d/osmocom-bsc-nat
22CONFIG_FILE=/etc/osmocom/osmocom-bsc-nat.cfg
23
24# Exit if the package is not installed
25[ -x $DAEMON ] || exit 0
26
27# Read configuration variable file if it is present
28[ -r /etc/default/osmocom-bsc-nat ] && . /etc/default/osmocom-bsc-nat
29
30# Load the VERBOSE setting and other rcS variables
31. /lib/init/vars.sh
32
33# Define LSB log_* functions.
34# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
35. /lib/lsb/init-functions
36
37DAEMON_ARGS="-D -c $CONFIG_FILE"
38
39#
40# Function that starts the daemon/service
41#
42do_start()
43{
44 # Return
45 # 0 if daemon has been started
46 # 1 if daemon was already running
47 # 2 if daemon could not be started
48 start-stop-daemon --start --quiet --exec $DAEMON --test > /dev/null \
49 || return 1
50 start-stop-daemon --start --quiet --exec $DAEMON -- \
51 $DAEMON_ARGS \
52 || return 2
53 # Add code here, if necessary, that waits for the process to be ready
54 # to handle requests from services started subsequently which depend
55 # on this one. As a last resort, sleep for some time.
56}
57
58#
59# Function that stops the daemon/service
60#
61do_stop()
62{
63 # Return
64 # 0 if daemon has been stopped
65 # 1 if daemon was already stopped
66 # 2 if daemon could not be stopped
67 # other if a failure occurred
68 start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --name $NAME
69 RETVAL="$?"
70 [ "$RETVAL" = 2 ] && return 2
71 # Wait for children to finish too if this is a daemon that forks
72 # and if the daemon is only ever run from this initscript.
73 # If the above conditions are not satisfied then add some other code
74 # that waits for the process to drop all resources that could be
75 # needed by services started subsequently. A last resort is to
76 # sleep for some time.
77 start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
78 [ "$?" = 2 ] && return 2
79 return "$RETVAL"
80}
81
82#
83# Function that sends a SIGHUP to the daemon/service
84#
85do_reload() {
86 #
87 # If the daemon can reload its configuration without
88 # restarting (for example, when it is sent a SIGHUP),
89 # then implement that here.
90 #
91 start-stop-daemon --stop --signal 1 --quiet $PIDFILE --name $NAME
92 return 0
93}
94
95case "$1" in
96 start)
97 [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME"
98 do_start
99 case "$?" in
100 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
101 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
102 esac
103 ;;
104 stop)
105 [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
106 do_stop
107 case "$?" in
108 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
109 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
110 esac
111 ;;
112 status)
113 status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
114 ;;
115 #reload|force-reload)
116 #
117 # If do_reload() is not implemented then leave this commented out
118 # and leave 'force-reload' as an alias for 'restart'.
119 #
120 #log_daemon_msg "Reloading $DESC" "$NAME"
121 #do_reload
122 #log_end_msg $?
123 #;;
124 restart|force-reload)
125 #
126 # If the "reload" option is implemented then remove the
127 # 'force-reload' alias
128 #
129 log_daemon_msg "Restarting $DESC" "$NAME"
130 do_stop
131 case "$?" in
132 0|1)
133 do_start
134 case "$?" in
135 0) log_end_msg 0 ;;
136 1) log_end_msg 1 ;; # Old process is still running
137 *) log_end_msg 1 ;; # Failed to start
138 esac
139 ;;
140 *)
141 # Failed to stop
142 log_end_msg 1
143 ;;
144 esac
145 ;;
146 *)
147 #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
148 echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
149 exit 3
150 ;;
151esac
152
153: